{-# LANGUAGE NoImplicitPrelude #-}
module Bamboo.Theme.Blueprint.Widget.Head where

import Bamboo.Type.Theme (css, js)
import Bamboo.Theme.Blueprint.Env
import Bamboo.Theme.Blueprint.Widget.Helper
import qualified Bamboo.Type as C
import qualified Bamboo.Type.State as S


html_head :: Widget
html_head s = header << (
  [ meta_tag
  , title_tag
  , favicon_tag
  , rss_tag
  ] 
  ++ s.config.theme_config.css.map (root > css_link)
  ++ s.config.theme_config.js.map (root > js_link)
  )
  where
    root = (s.env.slashed_script_name / )
    title_tag = thetitle << 
      [s.config.blog_title ++ s.S.resource_title.format_title]

    rss_tag = rss_link $ rss_url_link_pair s .fst
    favicon_tag = favicon_link $ root (s.config.favicon)

    format_title [] = ""
    format_title x = " / " ++ x
    